Option Explicit

Const VBModal = 1

'Define how many sprites are in use
Global Const MAX_SPRITES_USED = 3

'Define the sprites
Global Const INVADER_ID = 0
Global Const INVADER_FRM_FROM = 20
Global Const INVADER_FRM_TO = 21

Global Const PLAYER_ID = 1
Global Const PLAYER_FRM_FROM = 10
Global Const PLAYER_FRM_TO = 11

Global Const PLAYER_BULLET_ID = 2
Global Const PLAYER_BULLET_FRM_FROM = 12
Global Const PLAYER_BULLET_FRM_TO = 13

'Flags for monitoring movement keys
Global Const KEY_CUR_LEFT_FLAG = 1
Global Const KEY_CUR_RIGHT_FLAG = 2
Global Const KEY_FIRE_FLAG = 4

'KeyCode values for important keys
Global Const KEY_CUR_LEFT = 37
Global Const KEY_CUR_RIGHT = 39
Global Const KEY_FIRE = 32
Global Const KEY_ABORT = 65
Global Const KEY_PAUSE = 80
Global Const KEY_QUIT = 81

'Global Variables
Global giKeyStatus As Integer   'Holds movement key flags

Function iPrepSprites () As Integer

'Purpose    Allocate sprites used in this game
'Entry      None
'Exit       True if all sprites allocated

Dim i As Integer
Dim iRetVal As Integer
Dim tSpr As SprNewSprite

'Initialise the return code
iRetVal = True

'Get the invader
tSpr.iId = INVADER_ID
tSpr.iFirstFrame = INVADER_FRM_FROM
tSpr.iLastFrame = INVADER_FRM_TO
tSpr.iAnimFlag = True
tSpr.iAnimRate = 4
i = iSprAllocateSprite(tSpr)

'Activate the sprite
If i Then SprActivateSprite INVADER_ID, 10, 10

'Update return code
iRetVal = iRetVal And i

'Get the players sprite
tSpr.iId = PLAYER_ID
tSpr.iFirstFrame = PLAYER_FRM_FROM
tSpr.iLastFrame = PLAYER_FRM_TO
tSpr.iAnimFlag = True
tSpr.iAnimRate = 2
i = iSprAllocateSprite(tSpr)

'Activate the sprite
If i Then SprActivateSprite PLAYER_ID, 10, 170

'Update return code
iRetVal = iRetVal And i

'Get the players bullet sprite
tSpr.iId = PLAYER_BULLET_ID
tSpr.iFirstFrame = PLAYER_BULLET_FRM_FROM
tSpr.iLastFrame = PLAYER_BULLET_FRM_TO
tSpr.iAnimFlag = True
tSpr.iAnimRate = 3
i = iSprAllocateSprite(tSpr)

'Update return code
iRetVal = iRetVal And i

'Return success
iPrepSprites = iRetVal

End Function

Sub Main ()

Dim i As Integer

'Must initialise the array
ReDim gtSpr(MAX_SPRITES_USED)

'Load the game form
Load frmMain

'Get play area
i = iSprGetPlayDC(frmMain.hDC, 300, 200)

'Load sprite graphics
If i Then
    i = iSprLoadGfx(frmMain.picSpr, "eg.bmp")

    'Load sprite graphic frame data
    If i Then
        i = iSprLoadFrames("frames.mm1")

        'Get sprites & activate them
        If i Then
            i = iPrepSprites()

            'Show the form and let play commence!
            If i Then
                frmMain.Show VBModal
            End If
        End If
    End If
End If

'Make sure all resources are released
SprFreeAll

'Trash the form
Unload frmMain

End Sub

